package ImageDithering.ExactDither;

import RGBABitmapImage.RGBABitmapImage.RGBA;
import RGBABitmapImage.RGBABitmapImage.RGBABitmapImage;

import static Graphics2D.Graphics2D.Graphics2D.*;
import static Graphics2D.colors.colors.CreateRGBAColor;
import static Graphics2D.colors.colors.GetWhite;
import static color.ColorDistances.ColorDistances.ColorDistance;

import static java.lang.Math.*;

public class ExactDither {
    public static RGBABitmapImage ExactDither(RGBABitmapImage src, RGBA[] palette) {
        RGBABitmapImage dst;
        double x, y, d, m, p;
        boolean mset;
        RGBA srcColor, nextColor, paletteColor, choice;

        m = 0d;
        choice = new RGBA();
        dst = CreateImage(ImageWidth(src), ImageHeight(src), GetWhite());

        for(y = 0d; y < ImageHeight(src); y = y + 1d){
            for(x = 0d; x < ImageWidth(src); x = x + 1d) {
                mset = false;
                srcColor = GetImagePixel(src, x, y);
                if(x + 1d < ImageWidth(src)) {
                    nextColor = GetImagePixel(src, x + 1d, y);
                }else{
                    nextColor = GetWhite();
                }

                for(p = 0d; p < palette.length; p = p + 1d) {
                    paletteColor = palette[(int)p];
                    d = ColorDistance(srcColor, paletteColor);

                    if(!mset){
                        m = d;
                        mset = true;
                        choice = paletteColor;
                    }else{
                        if(d < m){
                            m = d;
                            choice = paletteColor;
                        }
                    }
                }

                nextColor.r = nextColor.r + (srcColor.r - choice.r);
                nextColor.g = nextColor.g + (srcColor.g - choice.g);
                nextColor.b = nextColor.b + (srcColor.b - choice.b);

                nextColor.r = max(-1d, min(1d, nextColor.r));
                nextColor.g = max(-1d, min(1d, nextColor.g));
                nextColor.b = max(-1d, min(1d, nextColor.b));

                SetPixel(dst, x, y, choice);
            }
        }

        return dst;
    }

    public static RGBA CopyColor(RGBA a) {
        RGBA b;

        b = CreateRGBAColor(a.r, a.g, a.b, a.a);

        return b;
    }
}






