package ImageDithering.SierraDither;

import RGBABitmapImage.RGBABitmapImage.RGBA;
import RGBABitmapImage.RGBABitmapImage.RGBABitmapImage;

import static Graphics2D.Graphics2D.Graphics2D.*;
import static Graphics2D.colors.colors.GetWhite;
import static color.ColorDistances.ColorDistances.ColorDistance;

import static java.lang.Math.*;

public class SierraDither {
    public static RGBABitmapImage SierraDither(RGBABitmapImage src, RGBA[] palette) {
        RGBABitmapImage dst;
        double x, y, d, m, p, w, h;
        boolean mset;
        RGBA srcColor, paletteColor, choice, c;

        m = 0d;
        choice = new RGBA();
        h = ImageHeight(src);
        w = ImageWidth(src);
        dst = CreateImage(w, h, GetWhite());

        for(y = 0d; y < h; y = y + 1d){
            for(x = 0d; x < w; x = x + 1d) {
                mset = false;
                srcColor = GetImagePixel(src, x, y);

                for(p = 0d; p < palette.length; p = p + 1d) {
                    paletteColor = palette[(int)p];
                    d = ColorDistance(srcColor, paletteColor);

                    if(!mset){
                        m = d;
                        mset = true;
                        choice = paletteColor;
                    }else{
                        if(d < m){
                            m = d;
                            choice = paletteColor;
                        }
                    }
                }

                // [4, 1]
                if (x + 1d < w) {
                    c = GetImagePixel(src, x + 1d, y);

                    c.r = c.r + (srcColor.r - choice.r) * 5d / 32d;
                    c.g = c.g + (srcColor.g - choice.g) * 5d / 32d;
                    c.b = c.b + (srcColor.b - choice.b) * 5d / 32d;

                    c.r = max(-1d, min(1d, c.r));
                    c.g = max(-1d, min(1d, c.g));
                    c.b = max(-1d, min(1d, c.b));
                }

                // [5, 1]
                if (x + 2d < w) {
                    c = GetImagePixel(src, x + 2d, y);

                    c.r = c.r + (srcColor.r - choice.r) * 3d / 32d;
                    c.g = c.g + (srcColor.g - choice.g) * 3d / 32d;
                    c.b = c.b + (srcColor.b - choice.b) * 3d / 32d;

                    c.r = max(-1d, min(1d, c.r));
                    c.g = max(-1d, min(1d, c.g));
                    c.b = max(-1d, min(1d, c.b));
                }

                // [1, 2]
                if (x > 2d && y + 1d < h) {
                    c = GetImagePixel(src, x - 2d, y + 1d);

                    c.r = c.r + (srcColor.r - choice.r) * 2d / 32d;
                    c.g = c.g + (srcColor.g - choice.g) * 2d / 32d;
                    c.b = c.b + (srcColor.b - choice.b) * 2d / 32d;

                    c.r = max(-1d, min(1d, c.r));
                    c.g = max(-1d, min(1d, c.g));
                    c.b = max(-1d, min(1d, c.b));
                }

                // [2, 2]
                if (x > 1d && y + 1d < h) {
                    c = GetImagePixel(src, x - 1d, y + 1d);

                    c.r = c.r + (srcColor.r - choice.r) * 4d / 32d;
                    c.g = c.g + (srcColor.g - choice.g) * 4d / 32d;
                    c.b = c.b + (srcColor.b - choice.b) * 4d / 32d;

                    c.r = max(-1d, min(1d, c.r));
                    c.g = max(-1d, min(1d, c.g));
                    c.b = max(-1d, min(1d, c.b));
                }

                // [3, 2]
                if (y + 1d < h) {
                    c = GetImagePixel(src, x, y + 1d);

                    c.r = c.r + (srcColor.r - choice.r) * 5d / 32d;
                    c.g = c.g + (srcColor.g - choice.g) * 5d / 32d;
                    c.b = c.b + (srcColor.b - choice.b) * 5d / 32d;

                    c.r = max(-1d, min(1d, c.r));
                    c.g = max(-1d, min(1d, c.g));
                    c.b = max(-1d, min(1d, c.b));
                }

                // [4, 2]
                if (x + 1d < w && y + 1d < h) {
                    c = GetImagePixel(src, x + 1d, y + 1d);

                    c.r = c.r + (srcColor.r - choice.r) * 4d / 32d;
                    c.g = c.g + (srcColor.g - choice.g) * 4d / 32d;
                    c.b = c.b + (srcColor.b - choice.b) * 4d / 32d;

                    c.r = max(-1d, min(1d, c.r));
                    c.g = max(-1d, min(1d, c.g));
                    c.b = max(-1d, min(1d, c.b));
                }

                // [5, 2]
                if (x + 2d < w && y + 1d < h) {
                    c = GetImagePixel(src, x + 2d, y + 1d);

                    c.r = c.r + (srcColor.r - choice.r) * 2d / 32d;
                    c.g = c.g + (srcColor.g - choice.g) * 2d / 32d;
                    c.b = c.b + (srcColor.b - choice.b) * 2d / 32d;

                    c.r = max(-1d, min(1d, c.r));
                    c.g = max(-1d, min(1d, c.g));
                    c.b = max(-1d, min(1d, c.b));
                }

                // [2, 3]
                if (x > 1d && y + 2d < h) {
                    c = GetImagePixel(src, x - 1d, y + 2d);

                    c.r = c.r + (srcColor.r - choice.r) * 2d / 32d;
                    c.g = c.g + (srcColor.g - choice.g) * 2d / 32d;
                    c.b = c.b + (srcColor.b - choice.b) * 2d / 32d;

                    c.r = max(-1d, min(1d, c.r));
                    c.g = max(-1d, min(1d, c.g));
                    c.b = max(-1d, min(1d, c.b));
                }

                // [3, 3]
                if (y + 2d < h) {
                    c = GetImagePixel(src, x, y + 2d);

                    c.r = c.r + (srcColor.r - choice.r) * 3d / 32d;
                    c.g = c.g + (srcColor.g - choice.g) * 3d / 32d;
                    c.b = c.b + (srcColor.b - choice.b) * 3d / 32d;

                    c.r = max(-1d, min(1d, c.r));
                    c.g = max(-1d, min(1d, c.g));
                    c.b = max(-1d, min(1d, c.b));
                }

                // [4, 3]
                if (x + 1d < w && y + 2d < h) {
                    c = GetImagePixel(src, x + 1d, y + 2d);

                    c.r = c.r + (srcColor.r - choice.r) * 2d / 32d;
                    c.g = c.g + (srcColor.g - choice.g) * 2d / 32d;
                    c.b = c.b + (srcColor.b - choice.b) * 2d / 32d;

                    c.r = max(-1d, min(1d, c.r));
                    c.g = max(-1d, min(1d, c.g));
                    c.b = max(-1d, min(1d, c.b));
                }

                SetPixel(dst, x, y, choice);
            }
        }

        return dst;
    }
}






