package color.ColorDistances;

import RGBABitmapImage.RGBABitmapImage.RGBA;

import static java.lang.Math.*;

public class ColorDistances {
    public static double ColorDistanceSimple(RGBA a, RGBA b) {
        return sqrt(pow(a.r - b.r, 2d) + pow(a.g - b.g, 2d) + pow(a.b - b.b, 2d));
    }

    public static double ColorDistance(RGBA a, RGBA b) {
        double dr, dg, db, rbar, dist;

        dr = a.r - b.r;
        dg = a.g - b.g;
        db = a.b - b.b;
        rbar = (a.r + b.r) / 2d;

        if(rbar < 0.5){
            dist = sqrt(2d*pow(dr, 2d) + 4d*pow(dg, 2d) + 3d*pow(db, 2d));
        }else{
            dist = sqrt(3d*pow(dr, 2d) + 4d*pow(dg, 2d) + 2d*pow(db, 2d));
        }

        return dist;
    }
}
